﻿using ProjectBattleship.DrawingObject;
namespace Battleship;

public class DrawingWarshipCompareByColor : IComparer<DrawingWarship?>
{
    public int Compare(DrawingWarship? x, DrawingWarship? y)
    {
        if (x == null && y == null) return 0;
        if (x == null || x.EntityWarship == null)
        {
            return 1;
        }

        if (y == null || y.EntityWarship == null)
        {
            return -1;
        }

        if (ToHex(x.EntityWarship.BodyColor) != ToHex(y.EntityWarship.BodyColor))
        {
            return String.Compare(ToHex(x.EntityWarship.BodyColor), ToHex(y.EntityWarship.BodyColor),
                StringComparison.Ordinal);
        }

        var speedCompare = x.EntityWarship.Speed.CompareTo(y.EntityWarship.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityWarship.Weight.CompareTo(y.EntityWarship.Weight);
    }

    private static String ToHex(Color c)
        => $"#{c.R:X2}{c.G:X2}{c.B:X2}";
}

