﻿using ProjectBattleship.Entities;
using System.Diagnostics.CodeAnalysis;
namespace ProjectBattleship.DrawingObject;
/// <summary>
/// Реализация сравнения двух объектов класса-прорисовки
/// </summary>
public class DrawiningWarshipEqutables : IEqualityComparer<DrawingWarship?>
{
    public bool Equals(DrawingWarship? x, DrawingWarship? y)
    {
        if (x == null || x.EntityWarship == null)
        {
            return false;
        }
        if (y == null || y.EntityWarship == null)
        {
            return false;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }
        if (x.EntityWarship.Speed != y.EntityWarship.Speed)
        {
            return false;
        }
        if (x.EntityWarship.Weight != y.EntityWarship.Weight)
        {
            return false;
        }
        if (x.EntityWarship.BodyColor != y.EntityWarship.BodyColor)
        {
            return false;
        }
        if (x is DrawingBattleship && y is DrawingBattleship)
        {
            if (((EntityBattleship)x.EntityWarship).AdditionalColor !=
                ((EntityBattleship)y.EntityWarship).AdditionalColor)
            {
                return false;
            }
            if (((EntityBattleship)x.EntityWarship).RocketCompartment !=
                ((EntityBattleship)y.EntityWarship).RocketCompartment)
            {
                return false;
            }
            if (((EntityBattleship)x.EntityWarship).Turret !=
                ((EntityBattleship)y.EntityWarship).Turret)
            {
                return false;
            }
        }
        return true;
    }
    public int GetHashCode([DisallowNull] DrawingWarship obj)
    {
        return obj.GetHashCode();
    }
}
